<template>
  <main>
    <section class="white-section">
      <div class="buttons">
        <button
          v-if="isTypeEnabled('rides')"
          class="select-button car"
          :class="{ selected: selected === RIDE }"
          @click="selected = RIDE"
        >
          <img
            src="~/assets/images/car.svg"
            alt="car-icon"
          >
          <h2 class="title">
            Véhicule léger
          </h2>
          <h3 class="title">
            <strong>1 à 7 personnes</strong>
          </h3>
          <p>
            Service e-Chauffeur historique,
            vous pouvez réserver un véhicule jusqu'à huit places pour un trajet ponctuel ou récurent
          </p>
          <div class="radio" />
        </button>
        <button
          v-if="isTypeEnabled('shuttles')"
          class="select-button shuttle"
          :class="{ selected: selected === SHUTTLE }"
          @click="selected = SHUTTLE"
        >
          <img
            src="~/assets/images/shuttle.svg"
            alt="shuttle-icon"
          >
          <h2 class="title">
            Navette
          </h2>
          <h3 class="title">
            <strong>8 à 50 personnes</strong>
          </h3>
          <p>
            Service e-Navette, permet de réserver par arrêt une place disponible sur une ligne de bus mise à disposition
          </p>
          <div class="radio" />
        </button>
      </div>
      <p class="transport-link">
        Il est également possible de réserver un transport ponctuel totalement paramétrable
        en appelant directement la régulation au <strong>{{ campus.phone ? campus.phone.everybody : '--' }}</strong>
      </p>
      <button
        class="button is-primary"
        @click="validateType"
      >
        Valider
      </button>
    </section>
  </main>
</template>

<script>
import {
  RIDE, SHUTTLE, isValidType,
} from '~/store/displacement';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Choisissez votre type de transport e-Chauffeur';
const SUBTITLE = 'Selon la capacité dont vous avez besoin.';

export default {
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
  ],
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      selected: null,
      campusId: this.campus.id,
      RIDE,
      SHUTTLE,
    };
  },
  methods: {
    validateType() {
      if (isValidType(this.selected)) {
        this.$router.push({
          name: this.selected === SHUTTLE ? 'campus-campus_id-shuttles-book' : `campus-campus_id-${this.selected}-new`,
          params: { campus_id: this.campusId },
        });
      } else {
        this.$toast.error('Veuillez sélectionner un type de transport');
      }
    },
    isTypeEnabled(type) {
      return !this.campus.modes || this.campus.modes.length === 0 || this.campus.modes.includes(type);
    },
  },
};
</script>

<style lang="scss" scoped>
@import '~assets/css/head';

.section {
  text-align: center;
  .title, .subtitle {
    max-width: 350px;
    margin: auto;
  }
}
.white-section {
  display: flex;
  flex-direction: column;
  align-items: center;
  margin-bottom: 2em;
  .transport-link {
    color: $blue-dark;
    width: 50%;
    text-align: center;
    font-weight: 700;
    margin-bottom: 1em;
    strong {
      font-size: 1.2em;
      color: $primary;
    }
  }
  .buttons {
    width: 50%;
    margin: 2em auto;
    display: grid;
    grid-gap: 1.5em;
    grid-template-areas:
      'car shuttle'
    ;
    button {
      position: relative;
      height: 100%;
      padding: 0 1em 2em 1em;
      background-color: $white;
      border: 3px solid $gray;
      border-radius: .5em;
      cursor: pointer;
      &:hover {
        border-color: $primary;
      }
      &.selected {
        border-color: $primary;
        background-color: rgba($light-gray, .5);
        .radio {
          background-color: $primary;
          box-shadow: inset 0 0 0 4px $light-gray;
        }
      }
      h2, h3 {
        font-size: 1.2em;
        color: inherit;
        margin: 0;
        font-weight: 500;
      }
      h3 {
        font-weight: 700;
      }
      img {
        transform: scale(.5);
      }
      .radio {
        position: absolute;
        background-color: $white;
        height: 2em;
        width: 2em;
        border: inherit;
        border-radius: 100%;
        left: calc(50% - 1em);
        bottom: -1em;
      }
      p {
        margin: 1em;
      }
      &.car {
        grid-area: car;
        color: $primary;
      }
      &.shuttle {
        grid-area: shuttle;
        color: $orange;
      }
    }
    .white-section > a:nth-child(2) {
      margin: auto !important;
      display: block;
    }
  }
  @media screen and (max-width: 600px) {
    .buttons {
      width: 80%;
      margin: 7em auto 2em;
      display: flex;
      flex-direction: column;
      button {
        width: 100%;
      }
    }

    .transport-link {
      width: 100%;
    }
  }
}

</style>
